<script lang="ts">
import Vue from 'vue';
import { Accordion } from '../solutions/index.vue';

export default Vue.extend({
  name: 'PlatformBenefits',
  components: { Accordion },
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      isOpenIndex: 0 as any,
    };
  },
  methods: {
    toggleController(index: number) {
      if (this.isOpenIndex === index) {
        this.isOpenIndex = null;
        return;
      }
      this.isOpenIndex = index;
    },
  },
});
</script>

<template>
  <section class="platform-benefits slp-py-48 slp-py-md-96">
    <SlpContainer>
      <SlpTypography
        tag="h2"
        variant="heading2-bold"
        class="gradient-header slp-mb-8"
      >
        {{ data.title }}
      </SlpTypography>
      <SlpTypography tag="h4" variant="heading4-bold" class="slp-mb-64">
        {{ data.subtitle }}
      </SlpTypography>

      <SlpRow class="platform-benefits__row">
        <SlpColumn :cols="6" class="slp-pr-md-16">
          <div
            v-if="data?.image?.image_url"
            class="platform-benefits__container"
          >
            <nuxt-img
              class="platform-benefits__image"
              :src="data.image.image_url"
              :alt="data.image.alt"
              aria-hidden="true"
              :data-aos="data.left_block_animation"
              :data-aos-duration="data.left_block_duration"
              loading="lazy"
              format="webp"
              quality="99"
            />
          </div>
        </SlpColumn>
        <SlpColumn :cols="6" class="slp-pl-md-16" size="lg">
          <div
            :data-aos="data.right_block_animation"
            :data-aos-duration="data.right_block_duration"
          >
            <div
              v-if="data.is_accordion"
              class="platform-benefits__items-wrapper"
            >
              <Accordion
                v-for="(item, index) in data.items"
                :key="item.header"
                :data="item"
                :is-open="isOpenIndex == index"
                @toggleController="toggleController(index)"
              />
            </div>
          </div>
          <div v-if="data.cta" class="slp-mt-64 slp-pr-lg-96">
            <SlpIcon
              class="platform-benefits__icon"
              :name="data.cta.icon"
              variant="marketing"
              size="md"
              slp-color="accent-400"
            />
            <SlpTypography tag="h4" variant="heading4" class="slp-mb-8">
              {{ data.cta.title }}
            </SlpTypography>
            <SlpButton
              variant="tertiary"
              :href="data.cta.link"
              class="cta"
              :data-ga-name="data.cta.data_ga_name"
              :data-ga-location="data.cta.data_ga_location"
            >
              {{ data.cta.text }}

              <SlpIcon variant="product" name="chevron-lg-right" />
            </SlpButton>
          </div>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.platform-benefits {
  position: relative;
  background: $color-surface-700;
  color: $color-text-50;
  .main-cta {
    margin: $spacing-24 0 $spacing-32;
  }

  &:deep {
    .accordion__icon:before,
    .accordion__icon:after {
      background-color: $color-text-50;
    }

    .accordion__header,
    .accordion {
      color: $color-text-50;

      .summary {
        border-top: none;
      }

      p {
        margin-left: $spacing-32;
        position: relative;

        &::before {
          content: '✓';
          position: absolute;
          color: $color-accent-400;
          height: 16px;
          left: -24px;
          top: 0;
        }
      }
    }
  }

  .gradient-header {
    background: linear-gradient(
      123deg,
      #f9a026 0%,
      #a686f2 45.5%,
      #592ac8 100%
    );
    -webkit-background-clip: text;
    background-clip: text;
    -webkit-text-fill-color: transparent;
  }

  .cta {
    text-align: left;
    color: $color-text-50;
  }
  &__row {
    width: 100%;
  }

  &__container {
    position: relative;
    @media (max-width: $breakpoint-lg) {
      margin-bottom: $spacing-48;
    }

    .platform-benefits__image {
      max-width: 450px;
      width: 100%;
      max-height: 800px;
    }
  }

  &__items-wrapper {
    max-width: 540px;
    width: 100%;
    color: white;

    @media (max-width: 1169px) {
      max-width: 100%;
    }
    & > :last-child {
      margin-bottom: 0;
    }
  }

  &__icon {
    margin-right: $spacing-default;
    margin-bottom: 20px;
  }

  &__description {
    padding-left: $spacing-48;
  }

  &__header {
    display: flex;
    align-items: center;
    font-weight: $font-weight-bold;
    margin-bottom: $spacing-4;
  }

  &__items-w-border {
    border-bottom: 1px solid $color-surface-200;
  }
}
.offset {
  @media (max-width: $breakpoint-lg) {
    display: none;
  }
}
</style>
